<template>
  <div id="CreateProject" class="container">
    <b-row>
      <div class="col-sm-2"></div>
      <div class="col-sm-8">
        <b-form id="edit_form" @submit.stop.prevent="onSubmit">
          <b-row v-show="isNewProject && isRWTHMember">
            <div class="col-sm-3"></div>
            <div class="col-sm-9">{{ $t("affliliationNotification") }}</div>
          </b-row>
          <coscine-form-group
            :mandatory="true"
            labelFor="ProjectName"
            :label="$t('projectNameLabel')"
            :isLoading="isLoading"
            type="input"
          >
            <b-form-input
              id="ProjectName"
              v-model="$v.form.ProjectName.$model"
              @input="translateProjectNameToDisplayName"
              aria-describedby="projectNameHelp"
              :state="
                $v.form.ProjectName.$dirty ? !$v.form.ProjectName.$error : null
              "
              :placeholder="$t('projectName')"
              maxlength="200"
              required="required"
              v-bind:disabled="!(isOwner || isNewProject)"
            />
            <div class="invalid-tooltip">{{ $t("projectNameHelp") }}</div>
          </coscine-form-group>
          <coscine-form-group
            :mandatory="true"
            labelFor="DisplayName"
            :label="$t('displayNameLabel')"
            :isLoading="isLoading"
            type="input"
          >
            <b-form-input
              id="DisplayName"
              v-model="$v.form.DisplayName.$model"
              @input="lockDisplayName"
              aria-describedby="displayNameHelp"
              :state="
                $v.form.DisplayName.$dirty ? !$v.form.DisplayName.$error : null
              "
              :placeholder="$t('displayName')"
              maxlength="25"
              required="required"
              v-bind:disabled="!(isOwner || isNewProject)"
            />
            <div class="invalid-tooltip">{{ $t("displayNameHelp") }}</div>
          </coscine-form-group>
          <coscine-form-group
            :mandatory="true"
            labelFor="Description"
            :label="$t('projectDescriptionLabel')"
            :isLoading="isLoading"
            type="input"
          >
            <b-form-textarea
              id="Description"
              v-model="$v.form.Description.$model"
              aria-describedby="DescriptionHelp"
              :state="
                $v.form.Description.$dirty ? !$v.form.Description.$error : null
              "
              :placeholder="$t('projectDescription')"
              maxlength="5000"
              required="required"
              v-bind:disabled="!(isOwner || isNewProject)"
            />
            <div class="invalid-tooltip">
              {{ $t("projectDescriptionHelp") }}
            </div>
          </coscine-form-group>
          <!-- copy metadata from parent -->
          <coscine-horizontal-divider />
          <div>
            <h5>{{ $t("activatedImportFromParent") }}</h5>
          </div>
          <div v-show="copyMetadataLabel !== ''">
            <coscine-form-group
              :mandatory="false"
              labelFor="CopyData"
              :label="copyMetadataLabel"
              :isLoading="isLoading"
              type="button"
            >
              <b-button
                variant="secondary"
                id="project_copy_button"
                @click.prevent="clickCopyMetadata"
                v-bind:disabled="!(isOwner || isNewProject)"
              >
                {{ $t("copyMetadataButton") }}</b-button
              >
            </coscine-form-group>
          </div>
          <coscine-form-group
            :mandatory="true"
            labelFor="PrincipleInvestigators"
            :label="$t('projectPrincipleInvestigatorsLabel')"
            :isLoading="isLoading"
            type="input"
          >
            <b-form-input
              id="PrincipleInvestigators"
              v-model="$v.form.PrincipleInvestigators.$model"
              aria-describedby="principleInvestigatorsHelp"
              :state="
                $v.form.PrincipleInvestigators.$dirty
                  ? !$v.form.PrincipleInvestigators.$error
                  : null
              "
              :placeholder="$t('projectPrincipleInvestigators')"
              maxlength="500"
              required="required"
              v-bind:disabled="!(isOwner || isNewProject)"
            />
            <div class="invalid-tooltip">
              {{ $t("projectPrincipleInvestigatorsHelp") }}
            </div>
          </coscine-form-group>
          <coscine-form-group
            :mandatory="true"
            labelFor="StartDate"
            :label="$t('projectStartLabel')"
            :isLoading="isLoading"
            type="input"
          >
            <b-form-datepicker
              id="StartDate"
              class="projectdatepicker"
              size="sm"
              :locale="$i18n.locale"
              v-model="form.StartDate"
              :disabled="!(isOwner || isNewProject)"
              @input="startDateSelected"
              @selected="startDateSelected"
              required="required"
              calendar-width="100%"
              start-weekday="1"
              :placeholder="$t('projectStart')"
            />
          </coscine-form-group>
          <coscine-form-group
            :mandatory="true"
            labelFor="EndDate"
            :label="$t('projectEndLabel')"
            :isLoading="isLoading"
            type="input"
          >
            <b-form-datepicker
              id="EndDate"
              class="projectdatepicker"
              size="sm"
              :locale="$i18n.locale"
              v-model="form.EndDate"
              :disabled-dates="disabledEndDates"
              :disabled="!(isOwner || isNewProject)"
              @input="dateSelected"
              @selected="dateSelected"
              required="required"
              calendar-width="100%"
              start-weekday="1"
              :placeholder="$t('projectEnd')"
            />
          </coscine-form-group>
          <coscine-form-group
            :mandatory="true"
            labelFor="Discipline"
            :label="$t('projectDisciplineLabel')"
            :isLoading="isLoading"
            type="input"
          >
            <multiselect
              id="Discipline"
              v-model="form.Discipline"
              v-bind:disabled="!(isOwner || isNewProject)"
              :options="disciplines"
              :multiple="true"
              :hide-selected="true"
              :label="disciplineLabel"
              :track-by="disciplineLabel"
              :placeholder="$t('projectDiscipline')"
            >
              <template
                slot="singleLabel"
                slot-scope="props"
                v-bind:disabled="!(isOwner || isNewProject)"
              >
                {{ props.option[disciplineLabel] }}
              </template>
              <template
                slot="option"
                slot-scope="props"
                v-bind:disabled="!(isOwner || isNewProject)"
              >
                {{ props.option[disciplineLabel] }}
              </template>
            </multiselect>
          </coscine-form-group>
          <coscine-form-group
            :mandatory="true"
            labelFor="Organization"
            :label="$t('projectOrganizationLabel')"
            :isLoading="isLoading"
            type="input"
          >
            <multiselect
              id="Organization"
              v-model="form.Organization"
              v-bind:disabled="!(isOwner || isNewProject)"
              :options="organizations"
              :multiple="true"
              :loading="loadingOrganizations"
              :hide-selected="true"
              label="displayName"
              track-by="url"
              :placeholder="$t('projectOrganization')"
              @search-change="triggerFetchOptions"
            >
              <template
                slot="singleLabel"
                slot-scope="props"
                v-bind:disabled="!(isOwner || isNewProject)"
              >
                {{ props.option.displayName }}
              </template>
              <template
                slot="option"
                slot-scope="props"
                v-bind:disabled="!(isOwner || isNewProject)"
              >
                {{ props.option.displayName }}
              </template>
              <template slot="noOptions">
                {{ $t("projectOrganizationNoOptions") }}
              </template>
            </multiselect>
          </coscine-form-group>
          <coscine-form-group
            labelFor="Keywords"
            :label="$t('projectKeywordsLabel')"
            :isLoading="isLoading"
            type="input"
          >
            <multiselect
              id="Keywords"
              v-model="form.Keywords"
              v-bind:disabled="!(isOwner || isNewProject)"
              :options="keywordoptions"
              :placeholder="$t('projectKeywords')"
              :multiple="true"
              :taggable="true"
              :tag-placeholder="$t('tagPlaceholder')"
              @tag="addTag"
            >
            </multiselect>
          </coscine-form-group>
          <coscine-form-group
            :mandatory="true"
            labelFor="Visibility"
            :label="$t('projectVisibilityLabel')"
            :isLoading="isLoading"
            type="input"
          >
            <b-form-radio-group
              v-model="form.Visibility.id"
              :options="visibilities"
              name="radios-stacked"
              stacked
              v-bind:disabled="!(isOwner || isNewProject)"
            ></b-form-radio-group>
          </coscine-form-group>
          <coscine-form-group
            labelFor="GrantId"
            :label="$t('projectGrantIdLabel')"
            :isLoading="isLoading"
            type="input"
          >
            <b-form-input
              id="GrantId"
              v-model="$v.form.GrantId.$model"
              aria-describedby="grantIdHelp"
              :state="$v.form.GrantId.$dirty ? !$v.form.GrantId.$error : null"
              :placeholder="$t('projectGrantId')"
              maxlength="500"
              required="required"
              v-bind:disabled="!(isOwner || isNewProject)"
            />
            <div class="invalid-tooltip">{{ $t("projectGrantIdHelp") }}</div>
          </coscine-form-group>
          <coscine-horizontal-divider />
          <div>
            <h5>{{ $t("activatedFeaturesHeadline") }}</h5>
          </div>
          <div>
            <b-skeleton-wrapper :loading="isLoading">
              <template #loading>
                <div style="width: 35%; margin-left: 8rem">
                  <b-skeleton type="text" animation="fade"></b-skeleton>
                  <b-skeleton type="text" animation="fade"></b-skeleton>
                  <b-skeleton type="text" animation="fade"></b-skeleton>
                </div>
              </template>
              <coscine-form-group
                v-for="feature in $v.features.$each.$iter"
                :key="feature.id.$model"
                :label-for="feature.id.$model"
                :label="feature.$model[language]"
              >
                <b-form-checkbox
                  :id="feature.id.$model"
                  v-model="feature.activated.$model"
                  switch
                ></b-form-checkbox>
              </coscine-form-group>
            </b-skeleton-wrapper>
          </div>
          <b-row>
            <delete-modal
              :projectId="projectId"
              :displayName="form.DisplayName"
              :projectParentId="form.ParentId"
              :languageLocale="languageLocale"
              v-show="isOwner"
            ></delete-modal>
            <b-button
              type="submit"
              variant="primary"
              class="btn-right"
              :disabled="
                $v.$invalid ||
                isWaitingForResponse ||
                isSavingProjectUpdates ||
                !$v.$anyDirty
              "
              name="save"
              @click.prevent="clickSave"
              v-show="isOwner || isNewProject"
            >
              <b-iconstack
                animation="spin"
                v-if="isSavingProjectUpdates"
                aria-hidden="true"
              >
                <b-icon
                  stacked
                  icon="dot"
                  aria-hidden="true"
                  shift-v="4"
                ></b-icon>
                <b-icon
                  stacked
                  icon="dot"
                  aria-hidden="true"
                  shift-v="-4"
                ></b-icon>
                <b-icon
                  stacked
                  icon="dot"
                  aria-hidden="true"
                  shift-h="4"
                ></b-icon>
                <b-icon
                  stacked
                  icon="dot"
                  aria-hidden="true"
                  shift-h="-4"
                ></b-icon>
              </b-iconstack>
              {{ $t("save") }}</b-button
            >
          </b-row>
        </b-form>
        <coscine-loading-spinner
          :isWaitingForResponse="isWaitingForResponse"
          :textAfter="isNewProject ? $t('loadingSpinnerProjectCreation') : ''"
        />
      </div>
      <div class="col-sm-2"></div>
    </b-row>
  </div>
</template>

<script lang="ts">
import {
  FormGroupPlugin,
  FormInputPlugin,
  FormDatepickerPlugin,
  ToastPlugin,
  BButton,
  BRow,
  BIconstack,
  BIcon,
  BIconDot,
  BSkeletonWrapper,
  BSkeleton,
} from "bootstrap-vue";
import Vue from "vue";
Vue.use(FormGroupPlugin);
Vue.use(FormInputPlugin);
Vue.use(FormDatepickerPlugin);
Vue.use(ToastPlugin);
Vue.component("b-button", BButton);
Vue.component("b-row", BRow);
Vue.component("b-iconstack", BIconstack);
Vue.component("b-icon", BIcon);
Vue.component("BIconDot", BIconDot);
Vue.component("b-skeleton-wrapper", BSkeletonWrapper);
Vue.component("b-skeleton", BSkeleton);
Vue.component("b-skeleton", BSkeleton);

import {
  CoscineLoadingSpinner,
  CoscineFormGroup,
  CoscineHorizontalDivider,
} from "@coscine/component-library";
import "@coscine/component-library/dist/index.css";
import { validationMixin } from "vuelidate";
import { required, minLength, maxLength } from "vuelidate/lib/validators";
import tag_inputs_helper from "./utils/tag_inputs_helper";
import {
  ProjectApi,
  ProjectRoleApi,
  DisciplineApi,
  OrganizationApi,
  VisibilityApi,
  ActivatedFeaturesApi,
} from "@coscine/api-connection";
import { GuidUtil, LinkUtil } from "@coscine/app-util";

import "@voerro/vue-tagsinput/dist/style.css";

import Multiselect from "vue-multiselect";
import "vue-multiselect/dist/vue-multiselect.min.css";

import DeleteModal from "./components/DeleteModal.vue";

import VueI18n from "vue-i18n";
Vue.use(VueI18n);

const i18n = new VueI18n({
  locale: "en",
  messages:
    window.coscine && window.coscine.i18n
      ? window.coscine.i18n["project-creation"]
      : undefined,
  silentFallbackWarn: true,
});

const defaultOrganizations = [
        { displayName: "FH Aachen", url: "https://ror.org/04tqgg260" },
        {
          displayName: "Karlsruhe Institute of Technology",
          url: "https://ror.org/04t3en479",
        },
        {
          displayName: "RWTH Aachen University",
          url: "https://ror.org/04xfq0f34",
        },
        {
          displayName: "Technical University of Munich",
          url: "https://ror.org/02kkvpp62",
        },
        { displayName: "TU Darmstadt", url: "https://ror.org/05n911h24" },
        {
          displayName: "TU Dortmund University",
          url: "https://ror.org/01k97gp34",
        },
        {
          displayName: "Universitätsklinikum Aachen",
          url: "https://ror.org/02gm5zw39",
        },
        {
          displayName: "University of Cologne",
          url: "https://ror.org/00rcxh774",
        },
        {
          displayName: "University of Duisburg-Essen",
          url: "https://ror.org/04mz5ra38",
        },
        {
          displayName: "University of Münster",
          url: "https://ror.org/00pd74e08",
        },
      ];

function checkKeywords(value: any) {
  return tag_inputs_helper.checkKeywords(value, 1000);
}
export default Vue.extend({
  i18n,
  mixins: [validationMixin],
  name: "CreateProject",
  components: {
    Multiselect,
    DeleteModal,
    CoscineLoadingSpinner,
    CoscineFormGroup,
    CoscineHorizontalDivider,
  },
  validations: {
    form: {
      ProjectName: {
        required,
        maxLength: maxLength(200),
      },
      DisplayName: {
        required,
        maxLength: maxLength(25),
      },
      Description: {
        required,
        maxLength: maxLength(5000),
      },
      StartDate: {
        required,
      },
      EndDate: {
        required,
      },
      PrincipleInvestigators: {
        required,
        maxLength: maxLength(500),
      },
      Discipline: {
        required,
      },
      Organization: {
        required,
      },
      Keywords: {
        checkKeywords,
      },
      Visibility: {
        required,
      },
      GrantId: {
        maxLength: maxLength(500),
      },
    },
    features: {
      $each: {
        activated: {
          required,
        },
        id: {
          required,
        },
      },
    },
  },
  data() {
    return {
      isSavingProjectUpdates: false,
      isLoading: false,
      language: this.$props.languageLocale,
      isNewProject: false,
      isOwner: false,
      isRWTHMember: false,
      isWaitingForResponse: false,
      displayNameIsLocked: false,
      disciplineLabel: "displayNameEn",
      form: {
        ProjectName: "",
        DisplayName: "",
        Description: "",
        PrincipleInvestigators: "",
        StartDate: new Date(),
        EndDate: new Date(),
        Discipline: [] as Array<unknown>,
        Organization: [] as Record<string, unknown>[],
        Keywords: [] as Array<unknown>,
        Visibility: {},
        GrantId: "",
        ParentId: String,
      },
      initialState: {
        ProjectName: "",
        DisplayName: "",
        Description: "",
        PrincipleInvestigators: "",
        StartDate: new Date(),
        EndDate: new Date(),
        Discipline: [] as Array<unknown>,
        Organization: [] as Record<string, unknown>[],
        Keywords: [] as Array<unknown>,
        Visibility: {},
        GrantId: "",
        ParentId: String,
      },
      disciplines: [] as Array<unknown>,
      organizations: defaultOrganizations,
      visibilities: [] as Array<unknown>,
      keywordoptions: [] as Array<unknown>,
      disabledEndDates: { to: new Date(1000, 1, 1) },
      features: [] as Array<unknown>,
      queryTimer: 0,
      // --- data for copyMetadata ----
      copyMetadataLabel: "",
      parentData: {},
      loadingOrganizations: false,
    };
  },
  props: {
    projectId: String,
    parentId: String,
    languageLocale: {
      default: "en",
      type: String,
    },
  },
  watch: {
    "form.Discipline"(newVal, oldVal) {
      if (oldVal.length > 0) {
        this.$v.form!.Discipline!.$touch();
      }
    },
    "form.Organization"(newVal, oldVal) {
      if (oldVal.length > 0) {
        this.$v.form!.Organization!.$touch();
      }
    },
    "form.Keywords"(newVal, oldVal) {
      if (oldVal.length > 0) {
        this.$v.form!.Keywords!.$touch();
      }
    },
  },
  methods: {
    makeToast(text = "Message", givenTitle = "Title") {
      this.$bvToast.toast(text, {
        title: givenTitle,
        autoHideDelay: 5000,
        toaster: "b-toaster-bottom-right",
        noCloseButton: true,
      });
    },
    addTag(newTag: any) {
      this.form.Keywords.push(newTag);
      this.keywordoptions.push(newTag);
    },
    clickClearForm() {
      this.tranferFormValues(this.initialState, this.form);
      if (this.isNewProject) {
        this.displayNameIsLocked = false;
      }
    },
    checkOwnership(projectRoles: any) {
      for (const projectRole in projectRoles) {
        if (projectRoles[projectRole].role.displayName === "Owner") {
          this.isOwner = true;
        }
      }
    },
    clickSave() {
      this.$v.$touch();
      if (this.$v.$anyError || !this.$v.$anyDirty) {
        return;
      }
      tag_inputs_helper.parseKeywords(this.form, ";");

      if (this.$props.parentId !== null && this.$props.parentId !== "") {
        this.form.ParentId = this.$props.parentId;
      }
      if (this.isNewProject) {
        this.isWaitingForResponse = true;
        ProjectApi.storeProject(this.form, (response: any) => {
          // activate initial features
          for (const feature of this.features) {
            if ((feature as any).activated) {
              ActivatedFeaturesApi.activateFeature(
                response.data.id,
                (feature as any).id
              );
            }
          }

          LinkUtil.redirectToExternalProject(response.data.slug);
          this.handleAfterSave();
        });
      } else {
        this.isSavingProjectUpdates = true;
        ProjectApi.updateProject(
          this.projectId,
          this.form,
          (response: any) => {
            // update features
            for (const feature of this.features) {
              if ((feature as any).activated) {
                ActivatedFeaturesApi.activateFeature(
                  this.projectId,
                  (feature as any).id
                );
              } else {
                ActivatedFeaturesApi.deactivateFeature(
                  this.projectId,
                  (feature as any).id
                );
              }
            }
            this.isSavingProjectUpdates = false;
            this.$v.$reset();
            this.makeToast(
              this.$t("toastMessages.saveSuccessfulMessage").toString(),
              this.$t("toastMessages.saveSuccessfulTitle").toString()
            );
          },
          (error: any) => {
            this.isSavingProjectUpdates = false;
            this.makeToast(
              this.$t("toastMessages.saveFailedMessage").toString(),
              this.$t("toastMessages.saveFailedTitle").toString()
            );
          }
        );
      }
    },
    handleAfterSave() {
      this.isWaitingForResponse = false;
      this.$v.$reset();
    },
    translateProjectNameToDisplayName() {
      if (this.displayNameIsLocked) {
        return;
      }
      this.form.DisplayName = this.form.ProjectName.substring(0, 25);
    },
    lockDisplayName() {
      this.displayNameIsLocked = true;
    },
    startDateSelected(selectedStartDate: Date) {
      if (selectedStartDate !== null) {
        this.form.StartDate = new Date(this.form.StartDate);
        this.disabledEndDates.to = selectedStartDate;
        if (new Date(this.form.EndDate) < this.disabledEndDates.to) {
          this.form.EndDate = this.disabledEndDates.to;
        }
      }
    },
    dateSelected() {
      if (new Date(this.form.EndDate) < this.disabledEndDates.to) {
        this.form.EndDate = this.disabledEndDates.to;
      } else {
        this.form.EndDate = new Date(this.form.EndDate);
      }
    },
    fillForm(data: any) {
      this.form.ProjectName = data.projectName;
      this.form.DisplayName = data.displayName;
      this.form.Description = data.description;
      this.fillProjectMetadata(data);
    },
    // ----- fillForm by parent information --------------
    fillProjectMetadata(data: any) {
      this.form.PrincipleInvestigators = data.principleInvestigators;
      this.form.StartDate = new Date(data.startDate);
      this.startDateSelected(new Date(this.form.StartDate));
      this.form.EndDate = new Date(data.endDate);
      this.form.Discipline = data.disciplines ? data.disciplines : [];
      this.form.Organization = data.organizations ? data.organizations : [];
      const keywords = data.keywords ? data.keywords.split(";") : [];
      this.form.Keywords = keywords;
      this.form.Visibility = data.visibility;
      this.form.GrantId = data.grantId;
      this.form.ParentId = data.parentId;
    },
    tranferFormValues(from: any, to: any) {
      to.ProjectName = from.ProjectName;
      to.DisplayName = from.DisplayName;
      to.Description = from.Description;
      to.PrincipleInvestigators = from.PrincipleInvestigators;
      to.StartDate = from.StartDate;
      to.EndDate = from.EndDate;
      to.Keywords = [] as Array<unknown>;
      for (const keyword in from.Keywords) {
        to.Keywords.push(from.Keywords[keyword]);
      }
      to.Organization = [] as Record<string, unknown>[];
      for (const organization in from.Organization) {
        to.Organization.push(from.Organization[organization]);
      }
      to.Discipline = [] as Array<unknown>;
      for (const discipline in from.Discipline) {
        to.Discipline.push(from.Discipline[discipline]);
      }
      to.Visibility = from.Visibility;
      to.GrantId = from.GrantId;
      to.ParentId = from.ParentId;
    },
    triggerFetchOptions(search: string) {
      clearTimeout(this.queryTimer);
      if (search === "" || search === " " ) { 
        this.organizations =defaultOrganizations; 
        return;
      }
      this.queryTimer = window.setTimeout(
        () => this.fetchOrganizationOptions(search),
        1000
      );
    },
    fetchOrganizationOptions(search: string) {
      this.loadingOrganizations = true;
      const newOrganizations: any = [];
      for (const organization of this.form.Organization) {
        newOrganizations.push(organization);
      }
      OrganizationApi.getOrganizationsWithFilter(
        search,
        (response: any) => {
          for (const org of response.data.data) {
            newOrganizations.push(org as any);
          }
          this.organizations = newOrganizations;
          this.loadingOrganizations = false;
        },
        (error: any) => {
          this.loadingOrganizations = false;
        }
      )
    },
    clickCopyMetadata() {
      if (this.parentData) {
        // --- set b-skeleton while filling parent-project form ---
        this.fillProjectMetadata(this.parentData);
        this.getLabels();
      }
    },
    setCopyMetadata(parentId: string) {
      this.isLoading = true;
      ProjectApi.getProjectInformation(parentId, (response: any) => {
        this.parentData = response.data;
        // ---- set label for copyMetadata -----
        const parentProjectName = response.data.projectName;
        this.copyMetadataLabel =
          this.$t("copyMetadataLabel") + ' "' + parentProjectName + '":';
        this.isLoading = false;
      });
    },
    getLabels() {
      for (const org of this.form.Organization) {
        OrganizationApi.getOrganization(org.url, (innerResponse: any) => {
          for (const innerOrg of innerResponse.data.data) {
            this.organizations.push(innerOrg as any);
            org.displayName = innerOrg.displayName;
          }
        });
      }
    },
  },
  async created() {
    this.isLoading = GuidUtil.isValidGuid(this.projectId) ? true : false;
    i18n.locale = this.$props.languageLocale;
    if (this.$props.languageLocale === "en") {
      this.disciplineLabel = "displayNameEn";
    } else {
      this.disciplineLabel = "displayNameDe";
    }

    this.startDateSelected(new Date());

    OrganizationApi.isRWTHMember((response: any) => {
      this.isRWTHMember = response.data.isMember;
    });

    VisibilityApi.getVisibilities((response: any) => {
      for (const visibility of response.data) {
        if (visibility.displayName === "Project Members") {
          this.initialState.Visibility = visibility;
          this.form.Visibility = visibility;
        }
        this.visibilities.push({
          text: visibility.displayName,
          value: visibility.id,
        });
      }
    });

    if (GuidUtil.isValidGuid(this.projectId)) {
      this.displayNameIsLocked = true;
      this.isNewProject = false;
      // Load features
      ActivatedFeaturesApi.listAllFeaturesOfProject(
        this.projectId,
        (response: any) => {
          response.data.forEach((feature: any) => {
            this.features.push(feature);
          });
        }
      );
      ProjectApi.getProjectInformation(this.projectId, (response: any) => {
        const parentId = response.data.parentId;
        if (GuidUtil.isValidGuid(parentId)) {
          this.setCopyMetadata(parentId);
        }
        this.fillForm(response.data);
        this.tranferFormValues(this.form, this.initialState);
        this.getLabels();
        this.isLoading = false;
      });
      ProjectRoleApi.getUserRoles(this.projectId, (response: any) => {
        this.checkOwnership(response.data);
      });
    } else {
      // --- get parent information ---
      if (GuidUtil.isValidGuid(this.parentId)) {
        this.setCopyMetadata(this.parentId);
      }
      ActivatedFeaturesApi.listAllFeatures((response: any) => {
        response.data.forEach((feature: any) => {
          this.features.push(feature);
        });
      });
      this.isNewProject = true;
      this.tranferFormValues(this.form, this.initialState);
    }
    const disciplines = await DisciplineApi.getDisciplines(
      (response: any) => response.data
    );
    for (const discipline of disciplines) {
      this.disciplines.push(discipline);
    }
  },
});
</script>

<style>
.projectdatepicker label {
  display: flex;
  align-items: center;
}
.projectdatepicker div.is-valid {
  background-image: unset;
}
.projectdatepicker footer {
  display: none;
}
.projectdatepicker button,
.b-calendar button {
  min-width: unset;
}
#CreateProject .multiselect {
  min-height: calc(1.4em + 0.75rem + 2px);
}
#CreateProject .multiselect__input {
  border: 0px;
  min-height: calc(1.4em + 0.75rem + 2px);
}
#CreateProject .multiselect__tags {
  border-radius: 0px;
}
#CreateProject .btn-right {
  margin-left: auto;
}
.multiselect__tag {
  background-color: #00549f !important;
}
.multiselect__option--highlight {
  background-color: #00549f !important;
  background: #00549f !important;
}
.multiselect__option--selected.multiselect__option--highlight {
  background-color: #a70619 !important;
}
.multiselect__tag-icon:focus,
.multiselect__tag-icon:hover {
  background-color: #a70619 !important;
}
.invalid-tooltip {
  position: absolute;
  top: 100%;
  z-index: 5;
  display: none;
  max-width: 100%;
  padding: 0.25rem 0.5rem;
  margin-top: 0.1rem;
  font-size: 0.76563rem;
  line-height: 1.4;
  color: #fff;
  background-color: rgba(204, 7, 30, 0.9);
  border-radius: 0;
}
.form-group .custom-control-label {
  vertical-align: super;
}
.b-skeleton-text {
  margin-top: 0.5rem;
}
</style>
